/*******************************************************************************
 * Copyright (c) 2011, 2012 IBM Corporation and others.
 *
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *  
 *  The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 *  and the Eclipse Distribution License is available at
 *  http://www.eclipse.org/org/documents/edl-v10.php.
 *  
 *  Contributors:
 *  
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.adaptors.basicexample;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletContextEvent;
import java.util.List;

import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import se.kth.md.adaptors.basicexample.BdServicesServiceProviderInfo;
import se.kth.md.adaptors.basicexample.ReqServicesServiceProviderInfo;
import se.kth.md.adaptors.basicexample.resources.Developer;
import se.kth.md.adaptors.basicexample.resources.ExtendedRequirement;
import se.kth.md.adaptors.basicexample.resources.Person;
import se.kth.md.adaptors.basicexample.resources.Requirement;
import se.kth.md.adaptors.basicexample.resources.SoftwareProduct;


// Start of user code imports
import org.eclipse.lyo.core.query.ParseException;
import org.eclipse.lyo.core.query.QueryUtils;
import org.eclipse.lyo.core.query.WhereClause;
import org.eclipse.lyo.oslc4j.core.OSLC4JUtils;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import se.kth.md.adaptors.basicexample.servlet.ServiceProviderCatalogSingleton;

import java.net.URISyntaxException;
import java.util.*;
import java.util.concurrent.ThreadLocalRandom;
// End of user code

// Start of user code pre_class_code
// End of user code

public class BasicAdaptorManager {

    // Start of user code class_attributes
    private static final Logger log = LoggerFactory.getLogger(BasicAdaptorManager.class);

    private static Integer lastDeveloperID, lastSoftwareProductID, lastExtendedRequirementID;

    private static Map<String, Developer> developers;
    private static Map<String, SoftwareProduct> softwareProducts;
    private static Map<String, ExtendedRequirement> requirements;

    private static final int nbOfDevsToCreate = 40;
    private static final int nbOfProductsToCreate = 60;
    private static final int nbOfReqsToCreate = 100;

    private static final int nbOfLinksBtwDevsAndProductsToCreate = 100;
    private static final int nbOfLinksBtwProductsAndRequirementsToCreate = 50;
    private static final int nbOfLinksBtwRequirementsAndProductsToCreate = 50;
    // End of user code
    
    
    // Start of user code class_methods
    // Just a test try OSLC query mechanisms
    private static final Map<String, String> PREFIX_MAP;
    static {
        Map<String, String> prefixes = new HashMap<String, String>();
        prefixes.put(OslcConstants.DCTERMS_NAMESPACE_PREFIX, OslcConstants.DCTERMS_NAMESPACE);
        prefixes.put(OslcConstants.OSLC_CORE_NAMESPACE_PREFIX, OslcConstants.OSLC_CORE_NAMESPACE);
        prefixes.put(OslcConstants.RDF_NAMESPACE_PREFIX, OslcConstants.RDF_NAMESPACE);
        prefixes.put(OslcConstants.RDFS_NAMESPACE_PREFIX, OslcConstants.RDFS_NAMESPACE);
        prefixes.put(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE_PREFIX, BasicAdaptorConstants.BASICDOMAIN_NAMSPACE);
        prefixes.put(BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_NAMSPACE_PREFIX, BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_NAMSPACE);
        PREFIX_MAP = Collections.unmodifiableMap(prefixes);
    }

    // Just a test try OSLC query mechanisms
    private static WhereClause parseWhere(String where, String prefixes) throws ParseException {
        Map<String, String> prefixMap = null;
        if (prefixes == null) {
            prefixMap = PREFIX_MAP;
        } else {
            try {
                prefixMap = QueryUtils.parsePrefixes(prefixes);
            } catch (ParseException e) {
                log.error("Bad oslc.prefix", e);
            }
        }
        try {
            return QueryUtils.parseWhere(where, prefixMap);
        } catch (ParseException e) {
            log.error("Bad oslc.where", e);
        }
        return null;
    }

    private static void generateDevelopers (int number) {
        for (Integer i = 0; i < number; i++) {
            try {
                Developer d = new Developer(BasicAdaptorConstants.BASIC_DOMAIN_SERVICE_PROVIDER_ID,
                        i.toString());
                d.setTitle(UUID.randomUUID().toString());
                d.setIdentifier(d.getAbout().toString());
                developers.put(i.toString(), d);
            } catch (URISyntaxException e) {
                e.printStackTrace();
            }
        }
    }

    private static void generateProducts (int number) {
        for (Integer i = 0; i < number; i++) {
            try {
                SoftwareProduct s = new SoftwareProduct(BasicAdaptorConstants.BASIC_DOMAIN_SERVICE_PROVIDER_ID,
                        i.toString());
                s.setTitle(UUID.randomUUID().toString());
                s.setLineOfCode(ThreadLocalRandom.current().nextInt(100, 5000));
                s.setIdentifier(s.getAbout().toString());
                softwareProducts.put(i.toString(), s);
            } catch (URISyntaxException e) {
                e.printStackTrace();
            }
        }
    }

    private static void generateRequirements (int number) {
        for (Integer i = 0; i < number; i++) {
            try {
                ExtendedRequirement r = new ExtendedRequirement(BasicAdaptorConstants.REQUIREMENT_DOMAIN_SERVICE_PROVIDER_ID,
                        i.toString());
                r.setTitle(UUID.randomUUID().toString());
                Date d1 = new Date(1000000000);
                Date d2 = new Date(1400000000);
                Date randomDate = new Date(ThreadLocalRandom.current().nextLong(d1.getTime(), d2.getTime()));
                r.setCreated(randomDate);
                r.setIdentifier(r.getAbout().toString());
                requirements.put(i.toString(), r);
            } catch (URISyntaxException e) {
                e.printStackTrace();
            }
        }
    }

    private static void generateLinksBtwDevsAndProducts (int number) {
        int dMin = 0, dMax = developers.size();
        int pMin = 0, pMax = softwareProducts.size();
        for (int i = 0; i < number; i++) {
            Integer randomD = ThreadLocalRandom.current().nextInt(dMin, dMax);
            Integer randomP = ThreadLocalRandom.current().nextInt(pMin, pMax);
            Developer d = developers.get(randomD.toString());
            SoftwareProduct p = softwareProducts.get(randomP.toString());
            HashSet<Link> previousLinks = d.getDevelops();
            HashSet<Link> newLinks = new HashSet<>();
            newLinks.addAll(previousLinks);
            Link l = new Link(p.getAbout());
            //URI uri = URI.create("http://annotation/XYZ");
            //l.setValue(uri);
            newLinks.add(l);
            d.setDevelops(newLinks);
        }
    }

    private static void generateLinksBtwProductsAndRequirements (int number) {
        int pMin = 0, pMax = softwareProducts.size();
        int rMin = 0, rMax = requirements.size();
        for (int i = 0; i < number; i++) {
            Integer randomP = ThreadLocalRandom.current().nextInt(pMin, pMax);
            Integer randomR = ThreadLocalRandom.current().nextInt(rMin, rMax);
            SoftwareProduct p = softwareProducts.get(randomP.toString());
            ExtendedRequirement r = requirements.get(randomR.toString());
            HashSet<Link> previousLinks = p.getRequirements();
            HashSet<Link> newLinks = new HashSet<>();
            newLinks.addAll(previousLinks);
            newLinks.add(new Link(r.getAbout()));
            p.setRequirements(newLinks);
        }
    }

    private static void generateLinksBtwRequirementsAndProducts (int number) {
        int pMin = 0, pMax = softwareProducts.size();
        int rMin = 0, rMax = requirements.size();
        for (int i = 0; i < number; i++) {
            Integer randomP = ThreadLocalRandom.current().nextInt(pMin, pMax);
            Integer randomR = ThreadLocalRandom.current().nextInt(rMin, rMax);
            SoftwareProduct p = softwareProducts.get(randomP.toString());
            ExtendedRequirement r = requirements.get(randomR.toString());
            HashSet<Link> previousLinks = r.getImplementedBy();
            HashSet<Link> newLinks = new HashSet<>();
            newLinks.addAll(previousLinks);
            newLinks.add(new Link(p.getAbout()));
            r.setImplementedBy(newLinks);
        }
    }
    // End of user code

    public static void contextInitializeServletListener(final ServletContextEvent servletContextEvent)
    {
        
        // Start of user code contextInitializeServletListener

        // FIXME: Frederic (March 2017):
        // There is an issue when creating the URI of querycapabilities when the adaptor
        // is deployed locally. In that case, the hostname of the URI will be retrieved
        // using the method "InetAddress.getLocalHost().getCanonicalHostName()"
        // (in org.eclipse.lyo.oslc4j.core.OSLC4JUtils, line 229) that most likely
        // will be different than the "localhost" commonly used for test the adaptor
        // locally.
        // The only fix I have found was to disable this hostresolution feature of oslc4j core
        // However, we don't want this feature to be disabled when the adaptor is
        // deployed on a remote machine on a tomcat web server.
        String configuredBaseUrl = servletContextEvent.getServletContext().getInitParameter("se.kth.md.adaptors.basicexample.servlet.baseurl");
        log.trace("baseurl: " + configuredBaseUrl);
        String serverInfo = servletContextEvent.getServletContext().getServerInfo();
        log.trace("serverinfo: " + serverInfo);
        if (configuredBaseUrl.contains("localhost") && serverInfo.startsWith("jetty/")) {
            OSLC4JUtils.setHostResolutionDisabled(true);
        }

        developers = new HashMap<>();
        softwareProducts = new HashMap<>();
        requirements = new HashMap<>();

        generateDevelopers(nbOfDevsToCreate);
        generateProducts(nbOfProductsToCreate);
        generateRequirements(nbOfReqsToCreate);

        lastDeveloperID = new Integer(nbOfDevsToCreate - 1);
        lastSoftwareProductID = new Integer(nbOfProductsToCreate - 1);
        lastExtendedRequirementID = new Integer(nbOfReqsToCreate - 1);


        generateLinksBtwDevsAndProducts(nbOfLinksBtwDevsAndProductsToCreate);
        generateLinksBtwProductsAndRequirements(nbOfLinksBtwProductsAndRequirementsToCreate);
        generateLinksBtwRequirementsAndProducts(nbOfLinksBtwRequirementsAndProductsToCreate);
        // End of user code
    }

    public static void contextDestroyServletListener(ServletContextEvent servletContextEvent) 
    {
        
        // Start of user code contextDestroyed
        // TODO Implement code to shutdown connections to data backbone etc...
        // End of user code
    }

    public static BdServicesServiceProviderInfo[] getBdServicesServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        BdServicesServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "BdServicesServiceProviderInfo[] getBdServicesServiceProviderInfos(...)"
        BdServicesServiceProviderInfo spi = new BdServicesServiceProviderInfo();
        spi.serviceProviderId = BasicAdaptorConstants.BASIC_DOMAIN_SERVICE_PROVIDER_ID;
        spi.name = BasicAdaptorConstants.BASIC_DOMAIN_SERVICE_PROVIDER_NAME;
        serviceProviderInfos = new BdServicesServiceProviderInfo[] {spi};
        // End of user code
        return serviceProviderInfos;
    }
    public static ReqServicesServiceProviderInfo[] getReqServicesServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        ReqServicesServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "ReqServicesServiceProviderInfo[] getReqServicesServiceProviderInfos(...)"
        ReqServicesServiceProviderInfo spi = new ReqServicesServiceProviderInfo();
        spi.serviceProviderId = BasicAdaptorConstants.REQUIREMENT_DOMAIN_SERVICE_PROVIDER_ID;
        spi.name = BasicAdaptorConstants.REQUIREMENT_SERVICE_PROVIDER_NAME;
        serviceProviderInfos = new ReqServicesServiceProviderInfo[] {spi};
        // End of user code
        return serviceProviderInfos;
    }

    public static List<SoftwareProduct> querySoftwareProducts(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<SoftwareProduct> resources = null;
        
        // Start of user code querySoftwareProducts
        resources = new ArrayList<>(softwareProducts.values());
        // End of user code
        return resources;
    }
    public static List<Developer> queryDevelopers(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<Developer> resources = null;
        
        // Start of user code queryDevelopers
        // Just a test for a where clause. Not implemented.
        WhereClause whereClause = null;
        if (where != null) {
            try {
                whereClause = parseWhere(where, null);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }

        resources = new ArrayList<>(developers.values());
        // End of user code
        return resources;
    }
    public static List<Developer> DeveloperSelector(HttpServletRequest httpServletRequest, final String serviceProviderId, String terms)   
    {
        List<Developer> resources = null;
        
        // Start of user code DeveloperSelector
        resources = new ArrayList<>(developers.values());
        // End of user code
        return resources;
    }
    public static Developer createDeveloper(HttpServletRequest httpServletRequest, final Developer aResource, final String serviceProviderId)
    {
        Developer newResource = null;
        
        // Start of user code createDeveloper
        lastDeveloperID++;
        aResource.setAbout(Developer.constructURI(BasicAdaptorConstants.BASIC_DOMAIN_SERVICE_PROVIDER_ID,
                lastDeveloperID.toString()));
        developers.put(lastDeveloperID.toString(), aResource);
        newResource = aResource;
        // End of user code
        return newResource;
    }
    public static SoftwareProduct createSoftwareProduct(HttpServletRequest httpServletRequest, final SoftwareProduct aResource, final String serviceProviderId)
    {
        SoftwareProduct newResource = null;
        
        // Start of user code createSoftwareProduct
        // TODO Implement code to create a resource
        // End of user code
        return newResource;
    }


    public static Developer getDeveloper(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        Developer aResource = null;
        
        // Start of user code getDeveloper
        aResource = developers.get(resourceId);
        // End of user code
        return aResource;
    }
    public static SoftwareProduct getSoftwareProduct(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        SoftwareProduct aResource = null;
        
        // Start of user code getSoftwareProduct
        aResource = softwareProducts.get(resourceId);
        // End of user code
        return aResource;
    }


    public static Developer updateDeveloper(HttpServletRequest httpServletRequest, final Developer aResource, final String serviceProviderId, final String resourceId) {
        Developer updatedResource = null;
        // Start of user code updateDeveloper
        if (!developers.containsKey(resourceId)) {
            return null;
        } else {
            developers.put(resourceId, aResource);
            updatedResource = aResource;
        }
        // End of user code
        return updatedResource;
    }
    public static SoftwareProduct updateSoftwareProduct(HttpServletRequest httpServletRequest, final SoftwareProduct aResource, final String serviceProviderId, final String resourceId) {
        SoftwareProduct updatedResource = null;
        // Start of user code updateSoftwareProduct
        // TODO Implement code to update and return a resource
        // End of user code
        return updatedResource;
    }

    public static List<ExtendedRequirement> queryExtendedRequirements(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<ExtendedRequirement> resources = null;
        
        // Start of user code queryExtendedRequirements
        resources = new ArrayList<>(requirements.values());
        // End of user code
        return resources;
    }
    public static List<ExtendedRequirement> ExtendedRequirementSelector(HttpServletRequest httpServletRequest, final String serviceProviderId, String terms)   
    {
        List<ExtendedRequirement> resources = null;
        
        // Start of user code ExtendedRequirementSelector
        resources = new ArrayList<>(requirements.values());
        // End of user code
        return resources;
    }


    public static ExtendedRequirement getExtendedRequirement(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        ExtendedRequirement aResource = null;
        
        // Start of user code getExtendedRequirement
        aResource = requirements.get(resourceId);
        // End of user code
        return aResource;
    }


    public static ExtendedRequirement updateExtendedRequirement(HttpServletRequest httpServletRequest, final ExtendedRequirement aResource, final String serviceProviderId, final String resourceId) {
        ExtendedRequirement updatedResource = null;
        // Start of user code updateExtendedRequirement
        // TODO Implement code to update and return a resource
        // End of user code
        return updatedResource;
    }


    public static String getETagFromSoftwareProduct(final SoftwareProduct aResource)
    {
        String eTag = null;
        // Start of user code getETagFromSoftwareProduct
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromDeveloper(final Developer aResource)
    {
        String eTag = null;
        // Start of user code getETagFromDeveloper
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromExtendedRequirement(final ExtendedRequirement aResource)
    {
        String eTag = null;
        // Start of user code getETagFromExtendedRequirement
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
}
